<!doctype html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport"
          content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>

<style>
    body{
        font-family: "Times New Roman";
        font-size: 16px;
    }
</style>


<body>

    <input type="text" id="inputMac" width="200px">
    <button id="buttonCalculate">Порахувати</button>

    <div id="fieldResult">
    </div>
</body>



<script>
    var inputMac = document.getElementById("inputMac");
    var fieldResult = document.getElementById("fieldResult");
    var buttonCalculate = document.getElementById("buttonCalculate");

    buttonCalculate.onclick = function ()
    {
        ShowResult();
    }

    function ShowResult() {
        inputMac.value = inputMac.value.replaceAll(" ", '');
        let rawMac = clearChars(inputMac.value);

        let chunked = chunk(rawMac, 2).join('-');
        let part = `${rawMac.substring(2, 4)}:${rawMac.substring(3, 5)}FF:FE${rawMac.substring(6, 8)}:${rawMac.substring(8)}`;
        let result =
            `
    <div>
    MAC-адреса  – ${inputMac.value} <br>
    Необхідно задану MAC-адресу інтерфейсу ${chunked} розбити на дві однакові частини, кожна довжиною три байти. Результат: <br>
    ${splitWord(chunked)}.<br>
    Старший байт цієї MAC-адреси 00 перевести у двійкову форму. Результат переведення: <br>
    00000000<br>
    Значення біту G/L змінюється на 1. Результат виконання цієї операції: <br>
    00000010<br>
    У шістнадцятковому вигляді<br>
    2.<br>
    Формується номер вузла. Результат формування: <br>
    2${part}<br>
    Номер мережі у нашому випадку дорівнює: <br>
    FE80:0000:0000:0000<br>
    або у скороченому форматі: <br>
    FE80::<br>
    Відповідно ІР-адреса версії 6 має вигляд у основному форматі: <br>
    FE80:0000:0000:0000:2${part}/64<br>
    у скороченому форматі: <br>
    FE80::2${part}/64.<br>

    </div>
    `;

        fieldResult.innerHTML = result;
    }

    function clearChars(str)
    {
        return str.replaceAll(".", '');
    }

    function splitWord(value)
    {
        return value.substring(0, 8) + " та " + value.substring(9);
    }

    function chunk(str, n) {
        let ret = [];
        let i;
        let len;

        for(i = 0, len = str.length; i < len; i += n) {
            ret.push(str.substr(i, n))
        }

        return ret
    }
</script>



</html>